package GCG.Clients.Interpreting;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.border.EmptyBorder;

import GCG.protokoll.PROTOKOLL;

/**
 * @version 5.0 vom 20.12.2015
 * @author Klaus Bovermann
 */
@SuppressWarnings("serial")
public class InterpretingGraphClientFrame extends JFrame {

	private JPanel contentPane;
	private JTextField ipEingabeFeld;
	private JTextField portEingabeFeld;

	private JButton btnVerbinden;

	private JTextArea ausgabeTextArea;
	private JScrollPane ausgabeScrollPane;
	private JPanel southPanel;
	private JTextField sendungEingabeFeld;
	private JButton btnNachrichtSchicken;

	private InterpretingGraphClient meinClient;
	private JLabel lblAnzahlFarben;
	private JButton btnAktiv;
	private JPanel southNorthPanel;
	private JPanel southSouthPanel;
	private JLabel lblFehlermeldung;

	/**
	 * Create the frame.
	 */
	public InterpretingGraphClientFrame() {
		setResizable(false);
		setTitle("GraphColoringGame");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 600, 459);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		contentPane.setLayout(new BorderLayout(0, 0));
		setContentPane(contentPane);

		JPanel northPanel = new JPanel();
		contentPane.add(northPanel, BorderLayout.NORTH);

		ipEingabeFeld = new JTextField();
		ipEingabeFeld.setText("localhost");
		northPanel.add(ipEingabeFeld);
		ipEingabeFeld.setColumns(10);

		portEingabeFeld = new JTextField();
		portEingabeFeld.setText("55555");
		northPanel.add(portEingabeFeld);
		portEingabeFeld.setColumns(10);

		btnVerbinden = new JButton("verbinden");
		btnVerbinden.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				verbinden();
			}
		});
		northPanel.add(btnVerbinden);

		ausgabeTextArea = new JTextArea();
		ausgabeTextArea.setPreferredSize(new Dimension(130, 20));
		ausgabeTextArea.setText("Weitere Meldungen");

		ausgabeScrollPane = new JScrollPane(ausgabeTextArea);
		ausgabeScrollPane.setPreferredSize(new Dimension(150, 50));
		contentPane.add(ausgabeScrollPane, BorderLayout.EAST);

		southPanel = new JPanel();
		contentPane.add(southPanel, BorderLayout.SOUTH);
		southPanel.setLayout(new BorderLayout(0, 0));

		southNorthPanel = new JPanel();
		southPanel.add(southNorthPanel, BorderLayout.NORTH);

		sendungEingabeFeld = new JTextField();
		southNorthPanel.add(sendungEingabeFeld);
		sendungEingabeFeld.setText("F:A:1");
		sendungEingabeFeld.setColumns(10);

		btnNachrichtSchicken = new JButton("--> Server");
		southNorthPanel.add(btnNachrichtSchicken);
		btnNachrichtSchicken.setEnabled(false);

		southSouthPanel = new JPanel();
		southPanel.add(southSouthPanel, BorderLayout.SOUTH);

		btnAktiv = new JButton("Nicht aktiv!");
		southSouthPanel.add(btnAktiv);
		btnAktiv.setEnabled(false);

		lblAnzahlFarben = new JLabel("Bisher keine Farbinfos!");
		southSouthPanel.add(lblAnzahlFarben);

		lblFehlermeldung = new JLabel("");
		southPanel.add(lblFehlermeldung, BorderLayout.CENTER);
		btnNachrichtSchicken.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				senden();
			}
		});
	}

	public void ausgeben(String message) {
		String[] teile = message.split(PROTOKOLL.TRENNER);
		this.lblFehlermeldung.setText("Fehler: --");
		switch (teile[0]) {
		case PROTOKOLL.SC_FARBZAHL:
			if (teile.length == 2) {
				this.lblAnzahlFarben.setText("Es gibt " + teile[1] + " Farben.");
			} else {
				this.lblFehlermeldung.setText("Fehler: " + "Farbanzahl beim Server unbekannt!");
			}
			break;
		case PROTOKOLL.SC_ERROR:
			if (teile.length == 2) {
				this.lblFehlermeldung.setText("Fehler: " + teile[1]);
			} else {
				this.lblFehlermeldung.setText("allgemeiner Fehler!");
			}
			break;
		case PROTOKOLL.SC_NAME:
			if (teile.length == 2) {
				this.setTitle("GraphColoringGame: " + teile[1]);
			} else {
				this.lblFehlermeldung.setText("Fehler: " + "Name vom Server nicht geschickt!");
			}
			break;
		case PROTOKOLL.SC_OK:
			if (teile.length == 2) {
				this.lblFehlermeldung.setText(teile[1]);
			} else {
				this.lblFehlermeldung.setText("OK ohne Angabe");
			}
			break;
		case PROTOKOLL.SC_AKTIV:
			this.btnAktiv.setText("Aktiv!");
			break;
		case PROTOKOLL.SC_INAKTIV:
			this.btnAktiv.setText("Nicht Aktiv!");
			break;
		case PROTOKOLL.SC_START:
			this.btnNachrichtSchicken.setEnabled(true);
			break;
		default:
			String bisher = this.ausgabeTextArea.getText();
			bisher = message + "\n" + bisher;
			this.ausgabeTextArea.setText(bisher);
		}

	}

	private void verbinden() {
		if (this.btnVerbinden.isEnabled()) {
			String serverIP = this.ipEingabeFeld.getText();
			int serverPort = Integer.valueOf(this.portEingabeFeld.getText());
			this.meinClient = new InterpretingGraphClient(serverIP, serverPort, this);
			this.btnVerbinden.setEnabled(false);
		}
	}

	private void senden() {
		if (this.btnNachrichtSchicken.isEnabled()) {
			String message = this.sendungEingabeFeld.getText();
			this.meinClient.send(message);
		}
	}
}
