package GCG.server;

/**
 * Ein Spieler hat einen Namen und kann aktiv sein.
 * 
 * Ein solcher Spieler wird im Server benutzt; er meldet sich von einer IP ueber
 * einen Port am Server an.
 * 
 * @version 3.1 vom 4.11.2015
 * @author Klaus Bovermann
 */
public class EinSpieler {

	private String ip;
	private int port;
	private String name;

	/**
	 * Der Name des Spielers wird zurueck geliefert
	 * 
	 * @return der Name
	 */
	public String getName() {
		return name;
	}

	/**
	 * Der Spieler bekommt einen Namen
	 * 
	 * @param pName
	 *            der (neue) Name
	 */
	public void setName(String pName) {
		this.name = pName;
	}

	private boolean aktiv;

	/**
	 * liefert genau dann true, wenn dieser Spieler aktiv ist
	 * 
	 * @return the aktiv
	 */
	public boolean isAktiv() {
		return aktiv;
	}

	/**
	 * @param pAktiv
	 *            die Aktivitaetsflagge
	 */
	public void setAktiv(boolean pAktiv) {
		this.aktiv = pAktiv;
	}

	/**
	 * Ein neuer Spieler wird erzeugt. Er hat einen "??" Namen und ist nicht
	 * aktiv.
	 * 
	 * @param pIp
	 *            Die IP dieses Spielers
	 * @param pPort
	 *            Der Port dieses Spielers
	 */
	public EinSpieler(String pIp, int pPort) {
		super();
		this.aktiv = false;
		this.ip = pIp;
		this.port = pPort;
		this.name = "??";
	}

	/**
	 * liefert die IP des Spielers, ueber den er sich am Server gemeldet hat
	 * 
	 * @return the ip
	 */
	public String getIp() {
		return ip;
	}

	/**
	 * liefert den Port des Spielers, ueber den er sich am Server gemeldet hat
	 * 
	 * @return the port
	 */
	public int getPort() {
		return port;
	}
}
