package GCG.server;

/**
 * 
 * @version 3.1 vom 4.11.2015
 * @author Klaus Bovermann
 *
 */
public class ZweiSpieler {

	private EinSpieler erster;
	private EinSpieler zweiter;
	private boolean gestartet;

	/**
	 * 
	 */
	public ZweiSpieler() {
		this.erster = null;
		this.zweiter = null;
		this.gestartet = false;
	}

	/**
	 * @return the erster
	 */
	public EinSpieler getErster() {
		return erster;
	}

	/**
	 * @return the zweiter
	 */
	public EinSpieler getZweiter() {
		return zweiter;
	}

	/**
	 * Der erste Spieler darf beginnen.
	 */
	public void start() {
		if (!gestartet) {
			this.getErster().setAktiv(true);
			this.getZweiter().setAktiv(false);
			this.gestartet = true;
		}
	}

	/**
	 * @return der Aktive Spieler
	 */
	public EinSpieler getAktiverSpieler() {
		if (!gestartet) {
			return null;
		} else if (this.getErster().isAktiv()) {
			return this.getErster();
		} else {
			return this.getZweiter();
		}
	}

	/**
	 * @return der Nicht-Aktive Spieler
	 */
	public EinSpieler getInaktiverSpieler() {
		if (!gestartet) {
			return null;
		} else if (this.getErster().isAktiv()) {
			return this.getZweiter();
		} else {
			return this.getErster();
		}
	}

	/**
	 * Das Recht, einen Zug zu machen, wechselt
	 */
	public void switchAktiverSpieler() {
		if (gestartet) {
			if (this.getErster().isAktiv()) {
				this.getErster().setAktiv(false);
				this.getZweiter().setAktiv(true);

			} else {
				this.getErster().setAktiv(true);
				this.getZweiter().setAktiv(false);
			}
		}
	}

	/**
	 * @param pIP
	 * @param pPort
	 */
	public void setErsterSpieler(String pIP, int pPort) {
		this.erster = new EinSpieler(pIP, pPort);
	}

	/**
	 * @param pIP
	 * @param pPort
	 */
	public void setZweiterSpieler(String pIP, int pPort) {
		this.zweiter = new EinSpieler(pIP, pPort);
		this.start();
	}

	/**
	 * @return
	 */
	public boolean istSpielGestartet() {
		return this.gestartet;
	}

	/**
	 * @param pIp
	 * @param pPort
	 * @return
	 */
	public String getName(String pIp, int pPort) {
		if (this.getErster().getIp().equals(pIp) && this.getErster().getPort() == pPort) {
			return this.getErster().getName();
		} else if (this.getZweiter().getIp().equals(pIp) && this.getZweiter().getPort() == pPort) {
			return this.getZweiter().getName();
		} else {
			return ("??");
		}
	}
}
